import { Mailbox } from './mailbox';
import { ProcessSystem } from './process_system';
import { PID, Reference } from '../erlang-types';
export declare type Monitor = {
    monitor: PID;
    monitee: PID;
};
export declare type Task = () => IterableIterator<any>;
export declare class Process {
    pid: PID;
    func: Task;
    args: any[];
    mailbox: Mailbox;
    system: ProcessSystem;
    status: Symbol;
    dict: Object;
    flags: Object;
    monitors: Array<Reference>;
    constructor(pid: PID, func: Task, args: any[], mailbox: Mailbox, system: ProcessSystem);
    start(): void;
    main(): IterableIterator<any>;
    process_flag(flag: any, value: any): any;
    is_trapping_exits(): boolean;
    signal(reason: any): void;
    receive(fun: any): symbol;
    run(machine: IterableIterator<any>, step: IteratorResult<any>): void;
}
